"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.renderer = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _style = _interopRequireDefault(require("../style"));

var _rules = _interopRequireDefault(require("../style/rules"));

var _utils = require("../utils");

var renderer = function renderer(Root, computeProps) {
  return function System(_ref) {
    var className = _ref.className,
        innerRef = _ref.innerRef,
        passedProps = (0, _objectWithoutProperties2.default)(_ref, ["className", "innerRef"]);

    var _computeProps = computeProps(passedProps),
        classList = _computeProps.classList,
        As = _computeProps.as,
        props = (0, _objectWithoutProperties2.default)(_computeProps, ["classList", "as"]);

    var Rendered = Root || As || 'div';
    var renderedProps = (0, _objectSpread2.default)({}, props, {
      ref: innerRef,
      className: _utils.cs.apply(void 0, [className].concat((0, _toConsumableArray2.default)(classList)))
    });

    if (Root && As) {
      renderedProps.as = As;
    }

    return _react.default.createElement(Rendered, renderedProps);
  };
};

exports.renderer = renderer;

var _default = (0, _style.default)(renderer)(_rules.default);

exports.default = _default;
//# sourceMappingURL=react.js.map