"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCache = getCache;
exports.setCache = setCache;

var _utils = require("../utils");

var cache = {};

function resolvePath(value, prop, pseudo, children, wrap) {
  var wrapPath = wrap ? ['$wrap', wrap] : [];
  var pseudoPath = pseudo ? ['$pseudo', pseudo] : [];
  var childPath = children ? ['$children', children] : [];
  var propPath = prop && (0, _utils.isDef)(value) ? [prop, value] : null;
  return propPath && wrapPath.concat(pseudoPath, childPath, propPath);
}

function getCache(value, prop, pseudo, children, wrap) {
  var path = resolvePath(value, prop, pseudo, children, wrap);
  return path ? (0, _utils.get)(cache, path) : cache;
}

function setCache(className, value, prop, pseudo, children, wrap) {
  var path = resolvePath(value, prop, pseudo, children, wrap);
  return path ? (0, _utils.set)(cache, path, className) : cache = className;
}
//# sourceMappingURL=cache.js.map