"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _css = _interopRequireDefault(require("./css"));

var _utils = require("../utils");

var META = ['$wrap', '$pseudo', '$children'];

function getMetaArgs(type, meta, pseudo, children, wrap) {
  switch (type) {
    case '$wrap':
      return [pseudo, children, meta];

    case '$pseudo':
      return [meta, children, wrap];

    case '$children':
      return [pseudo, meta, wrap];
  }
}

function computeClassNames(style, rules, pseudo, children, wrap) {
  var classNames = [];
  var computedStyle = {};
  (0, _utils.forEach)(style, function (value, prop) {
    // for meta rules go deeper except inside children rules
    if (META.includes(prop) && (0, _utils.isObj)(value) && !Boolean(children)) {
      (0, _utils.forEach)(value, function (metaStyle, meta) {
        var metaArgs = getMetaArgs(prop, meta, pseudo, children, wrap);
        var metaClassNames = computeClassNames.apply(void 0, [metaStyle, rules].concat((0, _toConsumableArray2.default)(metaArgs))); // prettier-ignore

        classNames.push.apply(classNames, (0, _toConsumableArray2.default)(metaClassNames));
      });
    } else if ((0, _utils.isDef)(value)) {
      var rule = typeof rules[prop] === 'string' ? rules[prop] : prop;
      computedStyle[(0, _utils.kebabCase)(rule)] = value;
    }
  });
  return (0, _css.default)(computedStyle, pseudo, children, wrap).concat(classNames);
}

var _default = computeClassNames;
exports.default = _default;
//# sourceMappingURL=classes.js.map