"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildCSS = buildCSS;
exports.default = createStyleSystem;
exports.methods = exports.meta = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _system = _interopRequireDefault(require("../system"));

var _keyframes = _interopRequireDefault(require("./keyframes"));

var _classes = _interopRequireDefault(require("./classes"));

var _utils = require("../utils");

var meta = {
  $wrap: true,
  $pseudo: true,
  $children: true
};
exports.meta = meta;

function buildCSS(uid, style, props, rules) {
  return {
    classList: [uid].concat((0, _toConsumableArray2.default)((0, _classes.default)(style, rules)))
  };
}

var methods = function methods(System) {
  return {
    animate: function animate(timing, steps) {
      var computedSteps = {};
      (0, _utils.forEach)(steps, function (style, step) {
        computedSteps[step] = System.compute(style);
      });
      var defaultAnim = System.defaults.animation;
      var computedAnim = (0, _keyframes.default)(computedSteps);
      var animation = [defaultAnim, "".concat(computedAnim, " ").concat(timing)].filter(Boolean).join(', ');
      var Animated = System.extend({
        animation: animation
      });
      Animated.animationName = computedAnim;
      return Animated;
    },
    toString: function toString() {
      return '.' + System.uid;
    }
  };
};

exports.methods = methods;

function createStyleSystem(renderer) {
  var system = (0, _system.default)(renderer, buildCSS, methods);
  return function (rules) {
    return system((0, _objectSpread2.default)({}, meta, rules));
  };
}
//# sourceMappingURL=index.js.map