"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = keyframes;

var _utils = require("../utils");

var _stylesheet = require("./stylesheet");

function toStep(props, step) {
  var css = [];
  (0, _utils.forEach)(props, function (v, p) {
    return css.push("".concat(p, ": ").concat(v, ";"));
  });
  return "".concat(step, " { ").concat(css.join(' '), " }");
}

function keyframes(steps) {
  var name = (0, _utils.uid)('k');
  var css = [];
  (0, _utils.forEach)(steps, function (p, s) {
    return css.push(toStep(p, s));
  });
  (0, _stylesheet.insertRule)("@keyframes ".concat(name, " { ").concat(css.join(' '), " }"));
  return name;
}
//# sourceMappingURL=keyframes.js.map