"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _computed = _interopRequireWildcard(require("./computed"));

var _transform = require("./transform");

var layout = {
  top: true,
  right: true,
  bottom: true,
  left: true,
  width: true,
  height: true,
  minWidth: true,
  minHeight: true,
  maxWidth: true,
  maxHeight: true
};
var margins = {
  margin: true,
  marginTop: true,
  marginRight: true,
  marginBottom: true,
  marginLeft: true
};
var padding = {
  padding: true,
  paddingTop: true,
  paddingRight: true,
  paddingBottom: true,
  paddingLeft: true
};
var fontSizes = {
  fontSize: true,
  lineHeight: true,
  letterSpacing: true
};
var borderSizes = {
  borderWidth: true,
  borderTopWidth: true,
  borderRightWidth: true,
  borderBottomWidth: true,
  borderLeftWidth: true
};
var background = {
  background: true,
  backgroundImage: true,
  backgroundOrigin: true,
  backgroundPosition: true,
  backgroundRepeat: true,
  backgroundSize: true,
  objectFit: true,
  objectPosition: true
};
var coloration = {
  backgroundColor: true,
  color: true,
  borderColor: true,
  borderTopColor: true,
  borderRightColor: true,
  borderBottomColor: true,
  borderLeftColor: true
};
var borders = {
  border: true,
  borderStyle: true,
  borderBottom: true,
  borderBottomStyle: true,
  borderLeft: true,
  borderLeftStyle: true,
  borderRight: true,
  borderRightStyle: true,
  borderTop: true,
  borderTopStyle: true,
  borderRadius: true,
  outline: true
};
var display = {
  display: true,
  position: true,
  float: true,
  zIndex: true,
  cursor: true,
  boxSizing: true,
  boxShadow: true,
  visibility: true,
  opacity: true,
  transform: true,
  listStyle: true,
  userSelect: true,
  overflow: true,
  overflowX: true,
  overflowY: true
};
var flexbox = {
  flex: true,
  flexBasis: true,
  flexDirection: true,
  flexGrow: true,
  flexShrink: true,
  flexWrap: true,
  justifyContent: true,
  alignContent: true,
  alignItems: true,
  alignSelf: true,
  order: true
};
var grid = {
  grid: true,
  gridArea: true,
  gridAutoColumns: true,
  gridAutoFlow: true,
  gridAutoRows: true,
  gridColumn: true,
  gridColumnEnd: true,
  gridColumnGap: true,
  gridColumnStart: true,
  gridGap: true,
  gridRow: true,
  gridRowEnd: true,
  gridRowGap: true,
  gridRowStart: true,
  gridTemplate: true,
  gridTemplateAreas: true,
  gridTemplateColumns: true
};
var fontFamily = {
  fontFamily: true
};
var fontStyles = {
  fontStyle: true,
  fontWeight: true,
  textAlign: true,
  textDecoration: true,
  textOverflow: true,
  textShadow: true,
  textTransform: true,
  wordBreak: true,
  wordSpacing: true,
  wordWrap: true,
  whiteSpace: true
};
var animations = {
  willChange: true,
  transition: true,
  animation: true,
  animationName: true,
  animationDelay: true,
  animationDuration: true,
  animationFillMode: true,
  animationDirection: true,
  animationPlayState: true,
  animationIterationCount: true,
  animationTimingFunction: true
};
var pseudos = {
  $hover: (0, _computed.pseudo)(':hover'),
  $disabled: (0, _computed.pseudo)(':disabled'),
  $active: (0, _computed.pseudo)(':active'),
  $focus: (0, _computed.pseudo)(':focus'),
  $before: (0, _computed.pseudo)('::before'),
  $after: (0, _computed.pseudo)('::after')
};
var aliases = {
  w: 'width',
  h: 'height',
  m: 'margin',
  mt: 'marginTop',
  mr: 'marginRight',
  mb: 'marginBottom',
  ml: 'marginLeft',
  mx: ['marginLeft', 'marginRight'],
  my: ['marginTop', 'marginBottom'],
  p: 'padding',
  pt: 'paddingTop',
  pr: 'paddingRight',
  pb: 'paddingBottom',
  pl: 'paddingLeft',
  px: ['paddingLeft', 'paddingRight'],
  py: ['paddingTop', 'paddingBottom'],
  b: 'border',
  bt: 'borderTop',
  br: 'borderRight',
  bb: 'borderBottom',
  bl: 'borderLeft',
  bx: ['borderLeft', 'borderRight'],
  by: ['borerTop', 'borderBottom'],
  bg: 'backgroundColor'
};
var basic = [_transform.responsive];
var fonts = [_transform.responsive, _transform.font];
var colors = [_transform.responsive, _transform.color];
var sizes = [_transform.responsive, _transform.pixel, _transform.zero];
var dimensions = [_transform.responsive, _transform.pixel, _transform.percent, _transform.zero];
var spacing = [_transform.responsive, _transform.pixel, _transform.percent, _transform.space, _transform.zero];

var _default = (0, _objectSpread2.default)({}, pseudos, (0, _computed.default)(layout, dimensions), (0, _computed.default)(margins, spacing), (0, _computed.default)(padding, spacing), (0, _computed.default)(fontSizes, sizes), (0, _computed.default)(fontFamily, fonts), (0, _computed.default)(fontStyles, basic), (0, _computed.default)(borderSizes, sizes), (0, _computed.default)(coloration, colors), (0, _computed.default)(display, basic), (0, _computed.default)(flexbox, basic), (0, _computed.default)(grid, basic), (0, _computed.default)(background, basic), (0, _computed.default)(borders, basic), (0, _computed.default)(animations, basic), (0, _computed.alias)(aliases));

exports.default = _default;
//# sourceMappingURL=index.js.map